package com.dsic.gj_erp.wsclient;

import com.alibaba.fastjson.JSONObject;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.web.socket.TextMessage;
import org.springframework.web.socket.WebSocketSession;
import org.springframework.web.socket.client.WebSocketClient;
import org.springframework.web.socket.client.WebSocketConnectionManager;
import org.springframework.web.socket.handler.TextWebSocketHandler;

@Service
@AllArgsConstructor
public class WebSocketService extends TextWebSocketHandler {

    private WebSocketSession session;

    private final WebSocketClient client;


    public void connect(String uri) {
        WebSocketConnectionManager manager = new WebSocketConnectionManager(client, this, uri);
        manager.start();
    }

    public void disconnect() throws Exception {
        if (session != null && session.isOpen()) {
            session.close();
        }
    }

    public void sendMessage(String message) throws Exception {
        if (session != null && session.isOpen()) {
            session.sendMessage(new TextMessage(message));
        } else {
            throw new IllegalStateException("WebSocket is not connected.");
        }
    }

    @Override
    public void afterConnectionEstablished(WebSocketSession session) throws Exception {
        this.session = session; // 处理连接后保存session
    }

    @Override
    protected void handleTextMessage(WebSocketSession session, TextMessage message) throws Exception {
        System.out.println("Received: " + message.getPayload());
        Message msg= JSONObject.parseObject(message.getPayload(),Message.class);
        switch (msg.getCodeEx()){
            case REG:
                break;
            case ZX:
                break;


        }
    }

}
